/**
 * Copyright (c) 2011-2018 EclipseSource Muenchen GmbH and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 * EclipseSource Muenchen GmbH - initial API and implementation
 */
package org.eclipse.emf.ecp.edit.internal.model.testData;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Test Data</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 * <li>{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getString <em>String</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#isBoolean <em>Boolean</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getInteger <em>Integer</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getLong <em>Long</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getFloat <em>Float</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getDouble <em>Double</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getStringMax8 <em>String Max8</em>}</li>
 * </ul>
 *
 * @see org.eclipse.emf.ecp.edit.internal.model.testData.TestDataPackage#getTestData()
 * @model
 * @generated
 */
public interface TestData extends EObject {
	/**
	 * Returns the value of the '<em><b>String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>String</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>String</em>' attribute.
	 * @see #setString(String)
	 * @see org.eclipse.emf.ecp.edit.internal.model.testData.TestDataPackage#getTestData_String()
	 * @model
	 * @generated
	 */
	String getString();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getString
	 * <em>String</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value the new value of the '<em>String</em>' attribute.
	 * @see #getString()
	 * @generated
	 */
	void setString(String value);

	/**
	 * Returns the value of the '<em><b>Boolean</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Boolean</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Boolean</em>' attribute.
	 * @see #setBoolean(boolean)
	 * @see org.eclipse.emf.ecp.edit.internal.model.testData.TestDataPackage#getTestData_Boolean()
	 * @model
	 * @generated
	 */
	boolean isBoolean();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#isBoolean
	 * <em>Boolean</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value the new value of the '<em>Boolean</em>' attribute.
	 * @see #isBoolean()
	 * @generated
	 */
	void setBoolean(boolean value);

	/**
	 * Returns the value of the '<em><b>Integer</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Integer</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Integer</em>' attribute.
	 * @see #setInteger(int)
	 * @see org.eclipse.emf.ecp.edit.internal.model.testData.TestDataPackage#getTestData_Integer()
	 * @model
	 * @generated
	 */
	int getInteger();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getInteger
	 * <em>Integer</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value the new value of the '<em>Integer</em>' attribute.
	 * @see #getInteger()
	 * @generated
	 */
	void setInteger(int value);

	/**
	 * Returns the value of the '<em><b>Long</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Long</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Long</em>' attribute.
	 * @see #setLong(long)
	 * @see org.eclipse.emf.ecp.edit.internal.model.testData.TestDataPackage#getTestData_Long()
	 * @model
	 * @generated
	 */
	long getLong();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getLong <em>Long</em>}'
	 * attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value the new value of the '<em>Long</em>' attribute.
	 * @see #getLong()
	 * @generated
	 */
	void setLong(long value);

	/**
	 * Returns the value of the '<em><b>Float</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Float</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Float</em>' attribute.
	 * @see #setFloat(float)
	 * @see org.eclipse.emf.ecp.edit.internal.model.testData.TestDataPackage#getTestData_Float()
	 * @model
	 * @generated
	 */
	float getFloat();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getFloat <em>Float</em>}'
	 * attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value the new value of the '<em>Float</em>' attribute.
	 * @see #getFloat()
	 * @generated
	 */
	void setFloat(float value);

	/**
	 * Returns the value of the '<em><b>Double</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Double</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Double</em>' attribute.
	 * @see #setDouble(double)
	 * @see org.eclipse.emf.ecp.edit.internal.model.testData.TestDataPackage#getTestData_Double()
	 * @model
	 * @generated
	 */
	double getDouble();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getDouble
	 * <em>Double</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value the new value of the '<em>Double</em>' attribute.
	 * @see #getDouble()
	 * @generated
	 */
	void setDouble(double value);

	/**
	 * Returns the value of the '<em><b>String Max8</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>String Max8</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>String Max8</em>' attribute.
	 * @see #setStringMax8(String)
	 * @see org.eclipse.emf.ecp.edit.internal.model.testData.TestDataPackage#getTestData_StringMax8()
	 * @model dataType="org.eclipse.emf.ecp.edit.internal.model.testData.StringWithMaxLength8"
	 * @generated
	 */
	String getStringMax8();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.edit.internal.model.testData.TestData#getStringMax8 <em>String
	 * Max8</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value the new value of the '<em>String Max8</em>' attribute.
	 * @see #getStringMax8()
	 * @generated
	 */
	void setStringMax8(String value);

} // TestData
